Index: messaging/src/main/org/jboss/mq/il/uil2/UILServerILService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/uil2/UILServerILService.java,v
retrieving revision 1.5.6.5
diff -b -B -U8 -r1.5.6.5 UILServerILService.java
--- messaging/src/main/org/jboss/mq/il/uil2/UILServerILService.java	15 Jul 2005 20:40:00 -0000	1.5.6.5
+++ messaging/src/main/org/jboss/mq/il/uil2/UILServerILService.java	26 Aug 2005 23:18:44 -0000
@@ -135,21 +135,22 @@
          try
          {
             socket = serverSocket.accept();
             if( trace )
                log.trace("Accepted connection: "+socket);
             socket.setSoTimeout(readTimeout);
             socket.setTcpNoDelay(enableTcpNoDelay);
             socketMgr = new SocketManager(socket);
-            ServerSocketManagerHandler handler = new ServerSocketManagerHandler(server, socketMgr);
+            ServerSocketManagerHandler handler = new ServerSocketManagerHandler(getJMSServer(), socketMgr);
             socketMgr.setHandler(handler);
             socketMgr.setBufferSize(bufferSize);
             socketMgr.setChunkSize(chunkSize);
-            socketMgr.start(server.getThreadGroup());
+            Invoker s = getJMSServer();
+            socketMgr.start(s.getThreadPool(), s.getThreadGroup());
          }
          catch (IOException e)
          {
             if (running)
                log.warn("Failed to setup client connection", e);
          }
          catch(Throwable e)
          {
@@ -163,17 +164,16 @@
     * Starts this IL, and binds it to JNDI
     *
     * @exception Exception  Description of Exception
     */
    public void startService() throws Exception
    {
       super.startService();
       running = true;
-      this.server = lookupJMSServer();
 
       // Use the default javax.net.ServerSocketFactory if none was set
       if (serverSocketFactory == null)
          serverSocketFactory = ServerSocketFactory.getDefault();
 
       /* See if the server socket supports setSecurityDomain(SecurityDomain)
       if an securityDomain was specified
       */
@@ -199,17 +199,17 @@
          }
       }
 
       // Create the server socket using the socket factory
       serverSocket = serverSocketFactory.createServerSocket(serverBindPort, 50, bindAddress);
 
       InetAddress socketAddress = serverSocket.getInetAddress();
       log.info("JBossMQ UIL service available at : " + socketAddress + ":" + serverSocket.getLocalPort());
-      acceptThread = new Thread(server.getThreadGroup(), this, "UILServerILService Accept Thread");
+      acceptThread = new Thread(getJMSServer().getThreadGroup(), this, "UILServerILService Accept Thread");
       acceptThread.start();
 
       /* We need to check the socketAddress against "0.0.0.0/0.0.0.0"
          because this is not a valid address on Win32 while it is for
          *NIX. See BugParade bug #4343286.
       */
       socketAddress = ServerConfigUtil.fixRemoteAddress(socketAddress);
       // If an explicit client bind address has been specified use it
Index: messaging/src/main/org/jboss/mq/server/BasicQueue.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/BasicQueue.java,v
retrieving revision 1.42.2.4
diff -b -B -U8 -r1.42.2.4 BasicQueue.java
--- messaging/src/main/org/jboss/mq/server/BasicQueue.java	27 Jul 2005 21:40:15 -0000	1.42.2.4
+++ messaging/src/main/org/jboss/mq/server/BasicQueue.java	26 Aug 2005 23:18:44 -0000
@@ -18,22 +18,23 @@
 
 import javax.jms.IllegalStateException;
 import javax.jms.JMSException;
 
 import org.jboss.logging.Logger;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.DestinationFullException;
 import org.jboss.mq.SpyJMSException;
+import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.Subscription;
 import org.jboss.mq.pm.Tx;
+import org.jboss.mq.pm.TxManager;
 import org.jboss.mq.selectors.Selector;
 import org.jboss.util.timeout.Timeout;
-import org.jboss.util.timeout.TimeoutFactory;
 import org.jboss.util.timeout.TimeoutTarget;
 
 import EDU.oswego.cs.dl.util.concurrent.ConcurrentHashMap;
 import EDU.oswego.cs.dl.util.concurrent.SynchronizedInt;
 
 /**
  *  This class represents a queue which provides it's messages exclusively to one
  *  consumer at a time.<p>
@@ -207,19 +208,17 @@
             for (Iterator it = messages.iterator(); it.hasNext();)
             {
                MessageReference message = (MessageReference) it.next();
                try
                {
                   if (message.isExpired())
                   {
                      it.remove();
-                     if (trace)
-                        log.trace("message expired: " + message);
-                     dropMessage(message);
+                     expireMessageAsync(message);
                   }
                   else if (sub.accepts(message.getHeaders()))
                   {
                      //queue message for sending to this sub
                      it.remove();
                      found = message;
                      break;
                   }
@@ -465,19 +464,17 @@
                // find a non-expired message
                while (messages.size() != 0)
                {
                   messageRef = (MessageReference) messages.first();
                   messages.remove(messageRef);
 
                   if (messageRef.isExpired())
                   {
-                     if (trace)
-                        log.trace("message expired: " + messageRef);
-                     dropMessage(messageRef);
+                     expireMessageAsync(messageRef);
                      messageRef = null;
                   }
                   else
                      break;
                }
             }
          }
          else
@@ -487,19 +484,17 @@
             {
                Iterator i = messages.iterator();
                while (i.hasNext())
                {
                   MessageReference mr = (MessageReference) i.next();
                   if (mr.isExpired())
                   {
                      i.remove();
-                     if (trace)
-                        log.trace("message expired: " + mr);
-                     dropMessage(mr);
+                     expireMessageAsync(mr);
                   }
                   else if (sub.accepts(mr.getHeaders()))
                   {
                      messageRef = mr;
                      i.remove();
                      break;
                   }
                }
@@ -547,21 +542,24 @@
             map.remove(unacked.messageRef);
          if (map == null || map.isEmpty())
            unackedBySubscription.remove(unacked.sub);
       }
 
       MessageReference m = unacked.messageRef;
 
       // Was it a negative acknowledge??
-      if (!item.isAck)
+      if (!item.isAck())
       {
-         Runnable task = new RestoreMessageTask(m);
+         Runnable task;
+         if (item.isExpiredAck())
+           task = new ExpireMessageTask(m);
+         else
+           task = new RestoreMessageTask(m);
          server.getPersistenceManager().getTxManager().addPostCommitTask(txId, task);
-
       }
       else
       {
          if (m.isPersistent())
             server.getPersistenceManager().remove(m, txId);
 
          Runnable task = new RestoreMessageTask(m);
          server.getPersistenceManager().getTxManager().addPostRollbackTask(txId, task);
@@ -815,47 +813,49 @@
          log.trace("removeReceiver " + " " + sub + " " + this);
 
       synchronized (receivers)
       {
          receivers.remove(sub);
       }
    }
 
+   private void addTimeout(MessageReference message, TimeoutTarget t, long ts)
+   {
+      Timeout timeout = server.getTimeoutFactory().schedule(ts, t);
+      events.put(message, timeout);
+   }
+
    /**
     * Add a message
     *
     * @param message the message to add
     */
    private void internalAddMessage(MessageReference message)
    {
       boolean trace = log.isTraceEnabled();
       if (trace)
          log.trace("internalAddMessage " + " " + message + " " + this);
 
       // If scheduled, put in timer queue
       long ts = message.messageScheduledDelivery;
       if (ts > 0 && ts > System.currentTimeMillis())
       {
-         EnqueueMessageTask t = new EnqueueMessageTask(message);
-         Timeout timeout = TimeoutFactory.createTimeout(ts, t);
-         events.put(message, timeout);
+         addTimeout(message, new EnqueueMessageTask(message), ts);
          scheduledMessageCount.increment();
          if (trace)
             log.trace("scheduled message at " + new Date(ts) + ": " + message);
          // Can't deliver now
          return;
       }
 
       // Don't bother with expired messages
       if (message.isExpired())
       {
-         if (trace)
-            log.trace("message expired: " + message);
-         dropMessage(message);
+         expireMessageAsync(message);
          return;
       }
 
       try
       {
          Subscription found = null;
          synchronized (receivers)
          {
@@ -878,20 +878,17 @@
                synchronized (messages)
                {
                   messages.add(message);
 
                   // If a message is set to expire, and nobody wants it, put its reaper in
                   // the timer queue 
                   if (message.messageExpiration > 0)
                   {
-                     // This could be a waste of memory for large numbers of expirations
-                     ExpireMessageTask t = new ExpireMessageTask(message);
-                     Timeout timeout = TimeoutFactory.createTimeout(message.messageExpiration, t);
-                     events.put(message, timeout);
+                     addTimeout(message, new ExpireMessageTask(message), message.messageExpiration);
                   }
                }
             }
          }
          
          // Queue to the receiver
          if (found != null)
             queueMessageForSending(found, message);
@@ -936,34 +933,33 @@
     *
     * @param sub the subscription receiving the message
     * @param messageRef the message to be acknowledged
     * @throws JMSException for any error
     */
    protected void setupMessageAcknowledgement(Subscription sub, MessageReference messageRef) throws JMSException
    {
       SpyMessage message = messageRef.getMessage();
-      AcknowledgementRequest ack = new AcknowledgementRequest();
-      ack.destination = message.getJMSDestination();
-      ack.messageID = message.getJMSMessageID();
-      ack.subscriberId = sub.subscriptionId;
-      ack.isAck = false;
+      AcknowledgementRequest nack = new AcknowledgementRequest(false);
+      nack.destination = message.getJMSDestination();
+      nack.messageID = message.getJMSMessageID();
+      nack.subscriberId = sub.subscriptionId;
 
       synchronized (messages)
       {
          UnackedMessageInfo unacked = new UnackedMessageInfo(messageRef, sub);
-         unacknowledgedMessages.put(ack, unacked);
-         unackedByMessageRef.put(messageRef, ack);
+         unacknowledgedMessages.put(nack, unacked);
+         unackedByMessageRef.put(messageRef, nack);
          HashMap map = (HashMap) unackedBySubscription.get(sub);
          if (map == null)
          {
             map = new HashMap();
             unackedBySubscription.put(sub, map);
          }
-         map.put(messageRef, ack);
+         map.put(messageRef, nack);
       }
    }
    /**
     * Remove a message
     *
     * @param message the message to remove
     */
    protected void dropMessage(MessageReference message)
@@ -1007,16 +1003,68 @@
          server.getMessageCache().remove(message);
       }
       catch (JMSException e)
       {
          log.warn("Error dropping message " + message, e);
       }
    }
 
+   /**
+    * Expire a message asynchronously.
+    *
+    * @param messageRef the message to remove
+    */
+   protected void expireMessageAsync(MessageReference messageRef)
+   {
+      server.getThreadPool().run(new ExpireMessageTask(messageRef));
+   }
+   
+   /**
+    * Expire a message
+    *
+    * @param messageRef the message to remove
+    */
+   protected void expireMessage(MessageReference messageRef)
+   {
+      boolean trace = log.isTraceEnabled();
+      if (trace)
+         log.trace("message expired: " + messageRef);
+
+      SpyDestination ed = parameters.expiryDestination;
+      if (ed == null)
+      {
+         dropMessage(messageRef);
+         return;
+      }
+
+      if (trace)
+         log.trace("sending to: " + ed);
+
+      try
+      {
+         SpyMessage orig = messageRef.getMessage();
+         SpyMessage copy = orig.myClone();
+         copy.header.jmsPropertiesReadWrite = true;
+         copy.setJMSExpiration(0);
+         copy.setJMSDestination(ed);
+         copy.setLongProperty(SpyMessage.PROPERTY_ORIG_EXPIRATION, orig.getJMSExpiration());
+         copy.setStringProperty(SpyMessage.PROPERTY_ORIG_DESTINATION, orig.getJMSDestination().toString());
+         TxManager tm = server.getPersistenceManager().getTxManager();
+         Tx tx = tm.createTx();
+         server.addMessage(null, copy, tx);
+         dropMessage(messageRef, tx);
+         tm.commitTx(tx);
+      }
+      catch (JMSException e)
+      {
+         log.error("Could not move expired message: " + messageRef, e);
+      }
+   }
+
    // Package Private -----------------------------------------------
 
    // Private -------------------------------------------------------
 
    /**
     * Check whether a removed subscription can be permenantly removed.
     * This method is private because it assumes external synchronization
     *
@@ -1162,17 +1210,17 @@
          internalAddMessage(messageRef);
          scheduledMessageCount.decrement();
       }
    }
 
    /**
     * Drop a message when it expires
     */
-   private class ExpireMessageTask implements TimeoutTarget
+   private class ExpireMessageTask implements TimeoutTarget, Runnable
    {
       private MessageReference messageRef;
 
       public ExpireMessageTask(MessageReference messageRef)
       {
          this.messageRef = messageRef;
       }
 
@@ -1181,19 +1229,22 @@
          events.remove(messageRef);
          synchronized (messages)
          {
             // If the message was already sent, then do nothing
             // (This probably happens more than not)
             if (messages.remove(messageRef) == false)
                return;
          }
-         if (log.isTraceEnabled())
-            log.trace("message expired: " + messageRef);
-         dropMessage(messageRef);
+         expireMessage(messageRef);
+      }
+
+      public void run()
+      {
+         expireMessage(messageRef);
       }
    }
 
    /**
     * Information about unacknowledged messages
     */
    private static class UnackedMessageInfo
    {
Index: messaging/src/main/org/jboss/mq/server/BasicQueueParameters.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/BasicQueueParameters.java,v
retrieving revision 1.4.4.2
diff -b -B -U8 -r1.4.4.2 BasicQueueParameters.java
--- messaging/src/main/org/jboss/mq/server/BasicQueueParameters.java	12 Jul 2005 17:12:02 -0000	1.4.4.2
+++ messaging/src/main/org/jboss/mq/server/BasicQueueParameters.java	26 Aug 2005 23:18:44 -0000
@@ -1,16 +1,18 @@
 /*
  * JBossMQ, the OpenSource JMS implementation
  *
  * Distributable under LGPL license.
  * See terms of license at gnu.org.
  */
 package org.jboss.mq.server;
 
+import org.jboss.mq.SpyDestination;
+
 /**
  * Parameters controlling a basic queue
  *
  * @author <a href="mailto:adrian@jboss.org">Adrian Brock</a>
  * @version $Revision: 1.4.4.2 $
  */
 public class BasicQueueParameters
 {
@@ -35,9 +37,12 @@
    /** The receivers implementation class */
    public Class receiversImpl;
    
    /** The message counter history */
    public int messageCounterHistoryDayLimit = -1;
    
    /** The number of retries when recovering a queue/durable subscription */
    public int recoveryRetries = 0;
+   
+   /** The destination that receives expired messages */
+   public SpyDestination expiryDestination = null;
 }
Index: messaging/src/main/org/jboss/mq/server/ClientConsumer.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/ClientConsumer.java,v
retrieving revision 1.21.6.2
diff -b -B -U8 -r1.21.6.2 ClientConsumer.java
--- messaging/src/main/org/jboss/mq/server/ClientConsumer.java	13 Oct 2004 15:18:55 -0000	1.21.6.2
+++ messaging/src/main/org/jboss/mq/server/ClientConsumer.java	26 Aug 2005 23:18:44 -0000
@@ -9,34 +9,34 @@
 import java.util.HashMap;
 import java.util.Iterator;
 import java.util.LinkedList;
 
 import javax.jms.InvalidDestinationException;
 import javax.jms.JMSException;
 
 import org.jboss.logging.Logger;
+import org.jboss.util.threadpool.ThreadPool;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.ReceiveRequest;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.Subscription;
-import org.jboss.mq.threadpool.ThreadPool;
 import org.jboss.mq.threadpool.Work;
 
 /**
  *  This represent the clients queue which consumes messages from the
  *  destinations on the provider.
  *
  * @author     Hiram Chirino (Cojonudo14@hotmail.com)
  * @author <a href="mailto:pra@tim.se">Peter Antman</a>
  * @created    August 16, 2001
  * @version    $Revision: 1.21.6.2 $
  */
-public class ClientConsumer implements Work
+public class ClientConsumer implements Runnable
 {
    private static Logger log = Logger.getLogger(ClientConsumer.class);
    //The JMSServer object
    JMSDestinationManager server;
    //The connection this queue will send messages over
    ConnectionToken connectionToken;
    //Is this connection enabled (Can we transmit to the receiver)
    boolean enabled;
@@ -58,30 +58,25 @@
    private boolean enqueued = false;
 
    // Static ---------------------------------------------------
 
    /**
     *  The {@link org.jboss.mq.threadpool.ThreadPool ThreadPool} that
     *  does the actual message pushing for us.
     */
-   private static ThreadPool threadPool = null;
+   private ThreadPool threadPool = null;
 
    // Constructor ---------------------------------------------------
 
    public ClientConsumer(JMSDestinationManager server, ConnectionToken connectionToken) throws JMSException
    {
       this.server = server;
       this.connectionToken = connectionToken;
-      // Create thread pool
-      synchronized (ClientConsumer.class)
-      {
-         if (threadPool == null)
-            threadPool = new ThreadPool("Message Pushers", server.threadGroup, 10, true);
-      }
+      this.threadPool = server.getThreadPool();
    }
 
    public void setEnabled(boolean enabled) throws JMSException
    {
       if (log.isTraceEnabled())
          log.trace("" + this +"->setEnabled(enabled=" + enabled + ")");
 
       // queues might be waiting for messages.
@@ -108,17 +103,17 @@
       synchronized (messages)
       {
          if (closed)
             return; // Wouldn't be delivered anyway
 
          messages.add(r);
          if (!enqueued)
          {
-            threadPool.enqueueWork(this);
+            threadPool.run(this);
             enqueued = true;
          }
       }
    }
 
    public void addSubscription(Subscription req) throws JMSException
    {
       if (log.isTraceEnabled())
@@ -144,19 +139,16 @@
       if (trace)
          log.trace("" + this +"->close()");
 
       synchronized (messages)
       {
          closed = true;
          if (enqueued)
          {
-            if (trace)
-               log.trace("" + this +"->close(): Cancelling work in progress.");
-            threadPool.cancelWork(this);
             enqueued = false;
          }
          messages.clear();
       }
 
       // Remove all the subscriptions for this client
       HashMap subscriptionsClone = null;
       synchronized (subscriptions)
@@ -247,17 +239,17 @@
 
       queue.removeSubscriber(req);
 
    }
 
    /**
     *  Push some messages.
     */
-   public void doWork()
+   public void run()
    {
       try
       {
 
          ReceiveRequest[] job;
 
          synchronized (messages)
          {
Index: messaging/src/main/org/jboss/mq/server/JMSDestinationManager.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/JMSDestinationManager.java,v
retrieving revision 1.17.6.3
diff -b -B -U8 -r1.17.6.3 JMSDestinationManager.java
--- messaging/src/main/org/jboss/mq/server/JMSDestinationManager.java	13 Apr 2005 18:43:24 -0000	1.17.6.3
+++ messaging/src/main/org/jboss/mq/server/JMSDestinationManager.java	26 Aug 2005 23:18:44 -0000
@@ -15,16 +15,18 @@
 import javax.jms.Destination;
 import javax.jms.InvalidDestinationException;
 import javax.jms.JMSException;
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 import javax.jms.Topic;
 
+import org.jboss.util.threadpool.ThreadPool;
+import org.jboss.util.timeout.TimeoutFactory;
 import org.jboss.logging.Logger;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.DurableSubscriptionID;
 import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyJMSException;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.SpyQueue;
@@ -62,18 +64,22 @@
    // Attributes
    /////////////////////////////////////////////////////////////////////
 
    /** Destinations SpyDestination -> JMSDestination */ 
    public Map destinations = new ConcurrentReaderHashMap();
    /** Destinations being closed SpyDestination -> JMSDestination */ 
    public Map closingDestinations = new ConcurrentReaderHashMap();
    //Thread group for server side threads.
+   /** Thread pool */
+   public ThreadPool threadPool;
    /** Thread group */
-   public ThreadGroup threadGroup = new ThreadGroup("JBossMQ Server Threads");
+   public ThreadGroup threadGroup;
+   /** Timeout factory */
+   public TimeoutFactory timeoutFactory;
 
    //The list of ClientConsumers hased by ConnectionTokens
    Map clientConsumers = new ConcurrentReaderHashMap();
 
    //last id given to a client
    private int lastID = 1;
    //last id given to a temporary topic
    private int lastTemporaryTopic = 1;
@@ -176,21 +182,41 @@
    /** Obtain a copy of the current clients
     * @return a HashMap<ConnectionToken, ClientConsumer> of current clients
     */
    public HashMap getClients()
    {
       return new HashMap(clientConsumers);
    }
 
+   public void setThreadPool(ThreadPool threadPool)
+   {
+      this.threadPool = threadPool;
+   }
+
+   public ThreadPool getThreadPool()
+   {
+      return threadPool;
+   }
+
+   public void setThreadGroup(ThreadGroup threadGroup)
+   {
+      this.threadGroup = threadGroup;
+   }
+
    public ThreadGroup getThreadGroup()
    {
       return threadGroup;
    }
 
+   public TimeoutFactory getTimeoutFactory()
+   {
+      return timeoutFactory;
+   }
+
    //Get a new ClientID for a connection
    /**
     * Gets the ID attribute of the JMSServer object
     *
     * @return   The ID value
     */
    public String getID()
    {
@@ -330,27 +356,29 @@
    /**
     * #Description of the Method
     */
    public void startServer()
    {
       synchronized (stateLock)
       {
          this.stopped = false;
+         this.timeoutFactory = new TimeoutFactory(this.threadPool);
       }
    }
 
    /**
     * #Description of the Method
     */
    public void stopServer()
    {
       synchronized (stateLock)
       {
          this.stopped = true;
+         this.timeoutFactory.cancel();
       }
    }
 
    /**
     * Check a clienID set by the client.
     *
     * @param ID                Description of Parameter
     * @exception JMSException  Description of Exception
Index: messaging/src/main/org/jboss/mq/server/JMSServerInterceptor.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/JMSServerInterceptor.java,v
retrieving revision 1.5
diff -b -B -U8 -r1.5 JMSServerInterceptor.java
--- messaging/src/main/org/jboss/mq/server/JMSServerInterceptor.java	5 Mar 2004 12:35:20 -0000	1.5
+++ messaging/src/main/org/jboss/mq/server/JMSServerInterceptor.java	26 Aug 2005 23:18:44 -0000
@@ -8,16 +8,17 @@
 
 import javax.jms.Destination;
 import javax.jms.JMSException;
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 import javax.jms.Topic;
 
+import org.jboss.util.threadpool.ThreadPool;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.DurableSubscriptionID;
 import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.SpyTopic;
 import org.jboss.mq.Subscription;
 import org.jboss.mq.TransactionRequest;
@@ -46,16 +47,22 @@
     * Get next invoker in chain to be called. Is mot often the real JMSServer
     */
    public JMSServerInterceptor getNext();
 
    /**
     * Get the thread group of the server.
     */
    public ThreadGroup getThreadGroup();
+
+   /**
+    * Get the thread pool of the server.
+    */
+   public ThreadPool getThreadPool();
+
    /**
     * Gets a clientID from server.
     *
     * @return               The ID value
     * @exception JMSException  Description of Exception
     */
    public String getID() throws JMSException;
 
Index: messaging/src/main/org/jboss/mq/server/JMSServerInterceptorSupport.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/JMSServerInterceptorSupport.java,v
retrieving revision 1.5
diff -b -B -U8 -r1.5 JMSServerInterceptorSupport.java
--- messaging/src/main/org/jboss/mq/server/JMSServerInterceptorSupport.java	5 Mar 2004 12:35:20 -0000	1.5
+++ messaging/src/main/org/jboss/mq/server/JMSServerInterceptorSupport.java	26 Aug 2005 23:18:45 -0000
@@ -9,16 +9,17 @@
 import javax.jms.Destination;
 import javax.jms.JMSException;
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 import javax.jms.Topic;
 
 import org.jboss.logging.Logger;
+import org.jboss.util.threadpool.ThreadPool;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.DurableSubscriptionID;
 import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.SpyTopic;
 import org.jboss.mq.Subscription;
 import org.jboss.mq.TransactionRequest;
@@ -61,16 +62,25 @@
 
    /**
     * Get the thread group of the server.
     */
    public ThreadGroup getThreadGroup()
    {
       return nextInterceptor.getThreadGroup();
    }
+
+   /**
+    * Returns the thread pool of the server.
+    */
+   public ThreadPool getThreadPool()
+   {
+      return nextInterceptor.getThreadPool();
+   }
+
    /**
     * Gets a clientID from server.
     *
     * @return               The ID value
     * @exception JMSException  Description of Exception
     */
    public String getID() throws JMSException
    {
Index: messaging/src/main/org/jboss/mq/server/JMSServerInvoker.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/JMSServerInvoker.java,v
retrieving revision 1.6
diff -b -B -U8 -r1.6 JMSServerInvoker.java
--- messaging/src/main/org/jboss/mq/server/JMSServerInvoker.java	5 Mar 2004 12:35:20 -0000	1.6
+++ messaging/src/main/org/jboss/mq/server/JMSServerInvoker.java	26 Aug 2005 23:18:45 -0000
@@ -9,16 +9,17 @@
 import javax.jms.Destination;
 import javax.jms.JMSException;
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 import javax.jms.Topic;
 
 import org.jboss.logging.Logger;
+import org.jboss.util.threadpool.ThreadPool;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.DurableSubscriptionID;
 import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyMessage;
 import org.jboss.mq.SpyTopic;
 import org.jboss.mq.Subscription;
 import org.jboss.mq.TransactionRequest;
@@ -62,16 +63,25 @@
 
    /**
     * Get the thread group of the server.
     */
    public ThreadGroup getThreadGroup()
    {
       return nextInterceptor.getThreadGroup();
    }
+
+   /**
+    * Get the thread pool of the server.
+    */
+   public ThreadPool getThreadPool()
+   {
+      return nextInterceptor.getThreadPool();
+   }
+
    /**
     * Gets a clientID from server.
     *
     * @return               The ID value
     * @exception JMSException  Description of Exception
     */
    public String getID() throws JMSException
    {
Index: messaging/src/main/org/jboss/mq/server/MessageCache.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/MessageCache.java,v
retrieving revision 1.31.2.1
diff -b -B -U8 -r1.31.2.1 MessageCache.java
--- messaging/src/main/org/jboss/mq/server/MessageCache.java	13 Apr 2005 17:58:26 -0000	1.31.2.1
+++ messaging/src/main/org/jboss/mq/server/MessageCache.java	26 Aug 2005 23:18:45 -0000
@@ -884,15 +884,15 @@
          return mostRecent;
       }
       public Node getLeastRecent()
       {
          return leastRecent;
       }
    }
 
-   class Node
+   static class Node
    {
       Node moreRecent = null;
       Node lessRecent = null;
       Object data = null;
    }
 }
Index: messaging/src/main/org/jboss/mq/server/MessageReference.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/MessageReference.java,v
retrieving revision 1.20.2.2
diff -b -B -U8 -r1.20.2.2 MessageReference.java
--- messaging/src/main/org/jboss/mq/server/MessageReference.java	12 Jul 2005 00:42:50 -0000	1.20.2.2
+++ messaging/src/main/org/jboss/mq/server/MessageReference.java	26 Aug 2005 23:18:45 -0000
@@ -172,17 +172,17 @@
       if (redeliveryDelay != 0)
       {
          log.trace("message has redelivery delay");
          messageScheduledDelivery = System.currentTimeMillis() + redeliveryDelay;
       }
 
       ++redeliveryCount;
       
-      if (queue.parameters.lateClone == false)
+      if (isLateClone() == false)
       {
          SpyMessage message = getMessage();
          message.setJMSRedelivered(redelivered);
 
          message.header.jmsProperties.put(SpyMessage.PROPERTY_REDELIVERY_COUNT, new Integer(redeliveryCount));
       }
    }
 
Index: messaging/src/main/org/jboss/mq/server/jmx/DestinationMBean.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/jmx/DestinationMBean.java,v
retrieving revision 1.7.4.2
diff -b -B -U8 -r1.7.4.2 DestinationMBean.java
--- messaging/src/main/org/jboss/mq/server/jmx/DestinationMBean.java	12 Jul 2005 17:12:02 -0000	1.7.4.2
+++ messaging/src/main/org/jboss/mq/server/jmx/DestinationMBean.java	26 Aug 2005 23:18:45 -0000
@@ -168,9 +168,20 @@
     * Returns the recovery retries
     */
    public int getRecoveryRetries();
 
    /**
     * Sets the class implementating the receivers
     */
    public void setRecoveryRetries(int retries);
+
+   /**
+    * Returns the expiry destination.
+    */
+   public ObjectName getExpiryDestination();
+
+   /**
+    * Sets the expiry destination.
+    */
+   public void setExpiryDestination(ObjectName destination);
+
 }
